;Program porownuje zawartosci dwoch obszarow i zwraca informacje o ilosci
;roznych komorek, lub o zachodzeniu na siebie sprawdzanych obszarow
;Zalozenie: obszar 2 lezy za obszarem 1

	ORG	$0010
	DB	$01,$00,$01,$0F,$01,$10

	ORG	$0020
	LDAB	#$FF	;Przygotowanie wyniku blednych adresow 1-go obszaru
	LDAA	$13	;Pobranie mlodszego bajtu adresu konca 1-go obszaru
	SUBA	$11	;i odjecie mlodszego bajtu adresu poczatku 1-go obszaru
	STAA	$17	;W 17h jest teraz mlodszy bajt dlugosci obszaru
	LDAA	$12	;Pobranie starszego bajtu adresu konca 1-go obszaru
	SBCA	$10	;i odjecie starszego bajtu adresu poczatku 1-go obszaru
	BCS	KONIEC	;Jesli dlugosc obszaru wyjdzie ujemna, to koniec programu
	STAA	$16	;W 16h jest teraz starszy bajt dlugosci obszaru
	
	LDAB	#$F0	;Przygotowanie wyniku bledu "wystawania" 2-go obszaru
	LDAA	$15	;Pobranie mlodszego bajtu adresu poczatku 2-go obszaru
	ADDA	$17	;i dodanie mlodszego bajtu dlugosci obszaru
	STAA	$19	;W 19h jest teraz mlodszy bajt adresu konca 2-go obszaru
	LDAA	$14	;Pobranie starszego bajtu adresu poczatku 2-go obszaru
	ADCA	$16	;i dodanie starszego bajtu dlugosci obszaru
	BCS	KONIEC	;Jesli wynik przekracza FFFFh to koniec programu
	STAA	$18	;W 18h jest teraz starszy bajt konca 2-go obszaru
	
	LDAB	#$00	;Przygotowanie wyniku bledu pokrywania sie obszarow
	LDX	$10	;Pobranie adresu komorki 1-go obszaru
	CPX	#$0100	;Porownanie z dopuszczalnym adresem poczatku obszaru
	BMI	koniec	;Jesli obszar 1 lezy ponizej 0100h to koniec
	LDX	$14	;Pobranie adresu komorki 2-go obszaru
	CPX	#$0100	;Jesli obszar 2 lezy ponizej 0100h to koniec
	BMI	KONIEC
	LDX	$12	;Pobranie adresu konca pierwszego obszaru
	CPX	$14	;i porownanie z poczatkiem drugiego obszaru
	BMI	START	;Jesli drugi obszar lezy za pierwszym to zaczynamy
	JMP	KONIEC	;Inaczej obszary zachodza na siebie i konczymy
		
START:	LDAA	#$00	;Przygotowanie licznika roznych komorek
	STAA	$18
	
POR:	LDX	$10	;Pobranie adresu komorki pierwszego obszaru
	LDAA	0,X	;Pobranie wartosci z komorki do akumulatora A
	INX		;Przesuniecie na kolejny adres
	STX	$10	;Zapis nowego adresu
	LDX	$14	;Pobranie adresu komorki drugiego obszaru
	LDAB	0,X	;Pobranie wartosci z komorki do akumulatora B
	SBA		;Porownanie odbedzie sie za pomoca flag N i Z
	BEQ	ROWNE	;Skok gdy rowne
	BCS	MNIEJ	;Skok gdy mniejsza w pierwszym obszarze
	CLR	0,X	;Zerowanie zawartosci komorki drugiego obszaru
	INC	$18	;Inkrementacja licznika roznych komorek
	JMP	ROWNE	;i koncowe instrukcjie petli
MNIEJ:	LDAB	#$DD
	STAB	0,X	;Do komorki drugiego obszaru zapisujemy liczbe DDh
	INC	$18	;Inkrementujemy licznik roznych komorek
ROWNE:	INX		;Przesuniecie na kolejny adres w drugim obszarze
	STX	$14	;Zapis nowego adresu
	LDX	$16	;Licznik do X
	BEQ	WYNIK	;Jesli licznik = 0, to konczymy
	DEX		;Dekremenracja licznika
	STX	$16	;Zapis licznika
	JMP	POR	;i kolejny obieg petli
	
wynik:	LDAB	$18	;Zapis liczby roznych komorek do akumulatora B
KONIEC:	JMP	KONIEC

	org	$0100
	db	$05,$20,$15,$1F,$F1,$32,$FF,$00,$10,$64,$F9,$15,$2A,$BB,$BA,$BE
	db	$05,$21,$07,$AA,$BB,$14,$17,$59,$E1,$EA,$38,$AE,$2C,$34,$27,$07
	end